/*
 *  glassBall.h
 *  openFrameworks
 *
 *  Created by Mr. Magoo on 2/4/09.
 *  Copyright 2009. All rights reserved.
 *
 */


#ifndef __GLASSBALL_H
#define __GLASSBALL_H

#ifndef OF_ADDON_USING_OFXOPENCV
#define OF_ADDON_USING_OFXOPENCV
#endif

#define GLASS_BALL_MOVIE_LENGTH 25
#define GLASS_BALL_SEQUENCE_LENGTH (GLASS_BALL_MOVIE_LENGTH / 4)

#include "ofMain.h"
#include "ofAddons.h"
#include "boundingBox.h"

class glassBall {
public:
	// default current_frame to 0
	glassBall();
	
	// allocate all the color images
	void setup(int x, int y, int width, int height, bool is_colorful = true);
	
	// add a frame to the stack
	void addFrame(ofxCvColorImage &color_img, int x, int y, int w, int h);
	void setColorful(bool is_colorful);
	
	// retrieve the next movie frame
	ofxCvColorImage * getNextFrame();
	
	// see if the glass_ball has face images loaded
	bool isLoaded()		{ return loaded; }
	
	void reset();
	
	boundingBox			coords;

	ofxCvColorImage		face_img[GLASS_BALL_MOVIE_LENGTH];
	int					width, height;
	int					current_frame_to_load;
	int					current_frame_to_play;
	int					random_counter;
	bool				loaded;
	bool				editable;
	bool				show;
	bool				colorful;
	int					num_frames;
};

#endif
